import java.io.PrintStream;
import java.util.Date;

/**
 * A small app that demonstrates the workings of the Date class
 * 
 * @author mb
 * 
 */
public class L05App01 {
	public static void main(String[] args) {
		PrintStream output = System.out;

		// a date object can be used to represent a point in time, relative to a
		// calendar (the Gregorian calendar in this case)

		// the key attribute of any date object is the
		// "time" value, which corresponds to the number
		// of msec that have elapsed since "unix epoch", which is:
		// Thu Jan 01 00:00:00 UTC 1970

		Date now = new Date(); // this is the default constructor, it takes as
								// the "time" value the number of msec that
								// have elapsed since "unix epoch" at the very
								// instant of invocation (during run-time, not
								// compile-time)

		output.print("Nicely formatted string equivalent of the \"now\" Date object: ");
		output.println(now.toString());
		output.print("Number of msec elapsed since unix epoch: ");
		output.println(now.getTime());

		long ONE_DAY = 1000 * 60 * 60 * 24; // 1000 msec per sec, 60 sec per
											// minute, 60 minutes per hour, 24
											// hours per day

		output.print("\"now\" plus one day later, nicely formatted: ");
		now.setTime(now.getTime() + ONE_DAY);
		output.println(now);
		output.print("\"now\" plus one day later, number of msec since epoch: ");
		output.println(now.getTime());

	}
}
