import java.io.PrintStream;
import java.util.Date;

import type.lib.CreditCard;

/**
 * @author mb
 * 
 */
public class L05App02 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		PrintStream output = System.out;
		int cardNumber = 111;
		String holderName = "Charles Oakley";
		CreditCard card1 = new CreditCard(cardNumber, holderName);

		output.print("Issue Date: ");
		output.println(card1.getIssueDate());
		output.print("Expiry Date: ");
		output.println(card1.getExpiryDate());
		output.println(card1.getLimit());

		output.println(card1.toString());

		// here we use the accessor of CreditCard to obtain a reference to the
		// Date object that represents the expiry date
		Date expiryDate = card1.getExpiryDate();
		output.print("Expiry Date: ");
		output.println(expiryDate);
		// use the accessor of Date to probe the time value of the expiry date
		// object
		output.println(expiryDate.getTime());
		long ONE_DAY = 1000 * 60 * 60 * 24;
		// use the mutator of Date to mutate the time value to be one day later
		expiryDate.setTime(expiryDate.getTime() + ONE_DAY);
		output.print("Expiry Date: ");
		// print out the date object so we can see that the mutator did
		// indeed change the date object
		output.println(expiryDate);
		output.print("Expiry Date: ");
		// access and print out the expiry date of the credit card
		output.println(card1.getExpiryDate());
		// COMMENTS: note that the output shows that the expiry date is
		// unchanged!!! The code above
		// did not actually change the credit card. Why not? because the
		// accessor
		// getExpiryDate() returned a reference to a *copy* of the date object,
		// not the date object itself. CreditCard completely encapsulates the
		// expiry date. Clients who want to modify a credit card object must
		// use CreditCard's mutator, setExpiryDate(Date), they can't use the
		// accessor. This behaviour makes CreditCard a composition (in addition
		// to being an aggregation).

	}
}
